Bug 1119087 - Review Request: python-voluptuous - A Python data validation library
Summary: Review Request: python-voluptuous - A Python data validation library
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Florian "der-flo" Lehner
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-07-13 23:30 UTC by Sergio Pascual
Modified: 2014-11-23 16:38 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-11-23 16:38:45 UTC
dev: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Sergio Pascual 2014-07-13 23:30:20 UTC
Spec URL: http://guaix.fis.ucm.es/~spr/fedora/python-voluptuous.spec
SRPM URL: http://guaix.fis.ucm.es/~spr/fedora/python-voluptuous-0.8.5-1.fc20.src.rpm
Description: Voluptuous, despite the name, is a Python data validation library. It is primarily intended for validating data coming into Python as JSON, YAML, etc.
Fedora Account System Username: sergiopr

Comment 1 Florian "der-flo" Lehner 2014-07-20 08:35:10 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.

   ---> Please add COPYING to the %files-section

[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 2 files have unknown license.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory names).

   ---> Please replace rm with %{__rm} and cp with %{__install}

[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[!]: Package complies to the Packaging Guidelines
   ---> there are issues mentioned above and below
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[ ]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
   ---> http://koji.fedoraproject.org/koji/taskinfo?taskID=7168662
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-voluptuous-0.8.5-1.fc22.noarch.rpm
          python-voluptuous-0.8.5-1.fc22.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python-voluptuous
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
python-voluptuous (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python-voluptuous:
    python-voluptuous



Source checksums
----------------
http://pypi.python.org/packages/source/v/voluptuous/voluptuous-0.8.5.tar.gz :
  CHECKSUM(SHA256) this package     : 493c645b3d383c213b4f9a677b676c5d3f2b704e487fbca68a26f4e68832df91
  CHECKSUM(SHA256) upstream package : 493c645b3d383c213b4f9a677b676c5d3f2b704e487fbca68a26f4e68832df91


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1119087
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

===== Solution =====
NOT APPROVED

Comment 2 Sergio Pascual 2014-07-21 16:01:13 UTC
(In reply to Florian "der-flo" Lehner from comment #1)

> [!]: If (and only if) the source package includes the text of the license(s)
>      in its own file, then that file, containing the text of the license(s)
>      for the package is included in %doc.
> 
>    ---> Please add COPYING to the %files-section

There is no COPYING in the tarball. Are you sure you are looking at the correct one?

> [!]: Package consistently uses macros (instead of hard-coded directory
> names).
> 
>    ---> Please replace rm with %{__rm} and cp with %{__install}
> 

This guideline is a about directory names, not command names. If fact, from the guidelines:

Macro forms of system executables SHOULD NOT be used except when there is a need to allow the location of those executables to be configurable. For example, rm should be used in preference to %{__rm}, but %{__python} is acceptable.

Comment 3 Sergio Pascual 2014-07-21 16:02:09 UTC
BTW, if you are doing the review, please assign the bug to yourself, thanks!

Comment 4 Florian "der-flo" Lehner 2014-07-21 17:17:04 UTC
(In reply to Sergio Pascual from comment #2)
> (In reply to Florian "der-flo" Lehner from comment #1)
> 
> > [!]: If (and only if) the source package includes the text of the license(s)
> >      in its own file, then that file, containing the text of the license(s)
> >      for the package is included in %doc.
> > 
> >    ---> Please add COPYING to the %files-section
> 
> There is no COPYING in the tarball. Are you sure you are looking at the
> correct one?

Thanks for that point.
What is about https://github.com/alecthomas/voluptuous/blob/master/COPYING ? Why isn't it included in the tarball?

And from voluptuous.py:

# This software is licensed as described in the file COPYING, which
# you should have received as part of this distribution.


> > [!]: Package consistently uses macros (instead of hard-coded directory
> > names).
> > 
> >    ---> Please replace rm with %{__rm} and cp with %{__install}
> > 
> 
> This guideline is a about directory names, not command names. If fact, from
> the guidelines:
> 
> Macro forms of system executables SHOULD NOT be used except when there is a
> need to allow the location of those executables to be configurable. For
> example, rm should be used in preference to %{__rm}, but %{__python} is
> acceptable.

Furthermore, it states:
Having macros in a Source: or Patch: line is a matter of style. Some people enjoy the ready readability of a source line without macros. Others prefer the ease of updating for new versions when macros are used.

And rpm --eval %{__rm} still works.

(In reply to Sergio Pascual from comment #3)
> BTW, if you are doing the review, please assign the bug to yourself, thanks!

I think changing the status to Assigned is more important. If you want to know who is responsible for this, one can also reference to the change. But you are right.

Comment 5 Sergio Pascual 2014-07-21 17:30:49 UTC
(In reply to Florian "der-flo" Lehner from comment #4)
> (In reply to Sergio Pascual from comment #2)
> > (In reply to Florian "der-flo" Lehner from comment #1)
> > 
> > > [!]: If (and only if) the source package includes the text of the license(s)
> > >      in its own file, then that file, containing the text of the license(s)
> > >      for the package is included in %doc.
> > > 
> > >    ---> Please add COPYING to the %files-section
> > 
> > There is no COPYING in the tarball. Are you sure you are looking at the
> > correct one?
> 
> Thanks for that point.
> What is about https://github.com/alecthomas/voluptuous/blob/master/COPYING ?
> Why isn't it included in the tarball?
> 
> And from voluptuous.py:
> 
> # This software is licensed as described in the file COPYING, which
> # you should have received as part of this distribution.
> 

Yes, this is a packaging error, I have reported it

https://github.com/alecthomas/voluptuous/issues/80 

I can use the zip from github instead. I will post a new spec

> 
> > > [!]: Package consistently uses macros (instead of hard-coded directory
> > > names).
> > > 
> > >    ---> Please replace rm with %{__rm} and cp with %{__install}
> > > 
> > 
> > This guideline is a about directory names, not command names. If fact, from
> > the guidelines:
> > 
> > Macro forms of system executables SHOULD NOT be used except when there is a
> > need to allow the location of those executables to be configurable. For
> > example, rm should be used in preference to %{__rm}, but %{__python} is
> > acceptable.
> 
> Furthermore, it states:
> Having macros in a Source: or Patch: line is a matter of style. Some people
> enjoy the ready readability of a source line without macros. Others prefer
> the ease of updating for new versions when macros are used.
> 
> And rpm --eval %{__rm} still works.
> 

I do not follow you here.



> (In reply to Sergio Pascual from comment #3)
> > BTW, if you are doing the review, please assign the bug to yourself, thanks!
> 
> I think changing the status to Assigned is more important. If you want to
> know who is responsible for this, one can also reference to the change. But
> you are right.

Assign to yourself so that you can search bugs assigned to you in bugziila. If you have a lot bugs is quite handy

Comment 6 Florian "der-flo" Lehner 2014-07-21 18:03:12 UTC
(In reply to Sergio Pascual from comment #5)
> Yes, this is a packaging error, I have reported it
> 
> https://github.com/alecthomas/voluptuous/issues/80 
> 
> I can use the zip from github instead. I will post a new spec

What about using the tarball from github?
Source0:		http://github.com/alecthomas/voluptuous/archive/%{version}.tar.gz#/%{upname}-%{version}.tar.gz

> > > > [!]: Package consistently uses macros (instead of hard-coded directory
> > > > names).
> > > > 
> > > >    ---> Please replace rm with %{__rm} and cp with %{__install}
> > > > 
> > > 
> > > This guideline is a about directory names, not command names. If fact, from
> > > the guidelines:
> > > 
> > > Macro forms of system executables SHOULD NOT be used except when there is a
> > > need to allow the location of those executables to be configurable. For
> > > example, rm should be used in preference to %{__rm}, but %{__python} is
> > > acceptable.
> > 
> > Furthermore, it states:
> > Having macros in a Source: or Patch: line is a matter of style. Some people
> > enjoy the ready readability of a source line without macros. Others prefer
> > the ease of updating for new versions when macros are used.
> > 
> > And rpm --eval %{__rm} still works.
> > 
> 
> I do not follow you here.

Sorry! My mistake - you are right

Comment 7 Sergio Pascual 2014-07-22 08:58:02 UTC
I have linked Source0 to the tarball in github, yes, better than the zip, thanks. 

I have added COPYING to the doc section

Spec: http://guaix.fis.ucm.es/~spr/fedora/python-voluptuous.spec
SRPM: http://guaix.fis.ucm.es/~spr/fedora/python-voluptuous-0.8.5-2.fc22.src.rpm

Comment 8 Florian "der-flo" Lehner 2014-07-22 15:14:05 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 3 files have unknown license. 
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
   ---> http://koji.fedoraproject.org/koji/taskinfo?taskID=7178205
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-voluptuous-0.8.5-2.fc22.noarch.rpm
          python-voluptuous-0.8.5-2.fc22.src.rpm
python-voluptuous.src:13: W: macro-in-comment %{upname}
python-voluptuous.src:13: W: macro-in-comment %{version}
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint python-voluptuous
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
python-voluptuous (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python-voluptuous:
    python-voluptuous



Source checksums
----------------
http://github.com/alecthomas/voluptuous/archive/0.8.5.tar.gz#/voluptuous-0.8.5.tar.gz :
  CHECKSUM(SHA256) this package     : 1237c0a1a5b48d79112f544f93ec17a1a002ed2ad33310e3e3e725aa5d3c183d
  CHECKSUM(SHA256) upstream package : 1237c0a1a5b48d79112f544f93ec17a1a002ed2ad33310e3e3e725aa5d3c183d


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1119087
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG


===== Solution =====
APPROVED

Comment 9 Sergio Pascual 2014-07-22 16:13:53 UTC
Thank you for the review!

Comment 10 Sergio Pascual 2014-07-22 16:17:10 UTC
New Package SCM Request
=======================
Package Name: python-voluptuous
Short Description: A Python data validation library
Upstream URL: http://github.com/alecthomas/voluptuous
Owners: sergiopr
Branches: f19 f20 f21 epel7
InitialCC:

Comment 11 Gwyn Ciesla 2014-07-22 18:48:49 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.